# NUCLEO-WL55JC Nucleo-64 board

## Overview

The NUCLEO-WL55JC STM32WL Nucleo-64 board, based on the MB1389 reference board (NUCLEO-WL55JC1 and NUCLEO-WL55JC2 order codes), provides an affordable and flexible way for users to try out new concepts and build prototypes with the STM32WL series microcontroller, choosing from the various combinations of performance, power consumption, and features. The ARDUINO® Uno V3 connectivity support and the ST morpho headers provide an easy means of expanding the functionality of the STM32WL Nucleo open development platform with a wide choice of specialized shields.

The STM32 Nucleo-64 board does not require any separate probe as it integrates the ST-LINK debugger/programmer.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um2592-stm32wl-nucleo64-board-mb1389-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32WL55JCI6 microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32wl55jc.html)
- [NUCLEO-WL55JC board](https://www.st.com/en/evaluation-tools/nucleo-wl55jc.html)
- [User manual](https://www.st.com/resource/en/user_manual/um2592-stm32wl-nucleo64-board-mb1389-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/nucleo-wl55jc.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/mb1389-wl55jc-lowband-d04_schematic.pdf)
